/************************************************************************
*																	   	*
*		MUX-Modul von Siegfried Goetz									*
*																		*
*		letzte Aenderung 12.06.92 										*
*																		*
************************************************************************/

/* Definitionen zur Funktion muxbit */
#define PULS   3
#define WRITE  2
#define CLR    0
#define SET    1
#define SETCLR 4

/************************************************************************
*																	   	*
* muxaddset:setzt die Input- und Outputadresse des MUX. 				*
* Eingabe:	inadd ist die Inputadresse									*
*			outadd ist die Outputadresse								*
* Ergebnis: 0 wenn alles ok, -1 (=Sendetimeout), -2 wenn die MUXoptoadd	*
*			nicht ermittelt werden konnte.								*
*																		*
************************************************************************/
int muxaddset(int inadd,int outadd);

/*************************************************************************
*                           						 *
* muxin : lie3t Mux-Buchse                                               *
*       Eingabe:	muxadd 	ist die Adresse der Muxbuchse            *
*                                                                        *
* Ergebnis: 0 wenn alles ok, -1 (=Sendetimeout), -2 wenn die MUXoptoadd  *
*			nicht ermittelt werden konnte.                   *
*	                                                                 *
**************************************************************************/
int muxin(int muxadd, int *wert);

/************************************************************************
*																	   	*
* muxbit :veraendert Bits an einer Outputbuchse  						*
* Eingabe:	muxadd 	ist die Adresse der Muxbuchse						*
*			bits 	gibt an welche Bits veraendert werden sollen:		*
*					z.B. bits = 0x3 => 0 & 1 werden verandert 2-15 		*
*					bleiben unverndert.								*
*			modus   1 => Bits werden gesetzt							*
*					0 => Bits werden geloescht							*
*					2 => alle bits werden bernommen					*
*					3 => Ausgabe eines Pulses an den angegebenen Bits 	*
*					4 => Bits werden gesetzt und ...-Bits werden 		*
*						 geloescht d.h. es muss eine weitere unsigned   *
*						 Zahl der zu loeschenden Bits angegeben werden	*
* Ergebnis: 0 wenn alles ok, -1 (=Sendetimeout), -2 wenn die MUXoptoadd	*
*			nicht ermittelt werden konnte.								*
*																		*
************************************************************************/
int muxbit(int muxadd,unsigned bit,int modus,...);

/********************************************************************************
*																				*																			 																					 
*  	muxstat:  Erzeugt wenn noch nicht vorhanden eine Status und eine Protokoll- *
*			  datei fr eine MUXoutputbuchse. Die Bitkombination wird ausgegeben*
*																				*																			 																					 
*	so gehts: muxstat(bnr,string)												*
*	bnr  	 = Buchsennummer (0-13)												*
*	string   = ein Text der wenn vorhanden anstelle der Bitkombination 			*
*			   ausgegeben wird.													*
*																				*
*********************************************************************************/
void muxstat(int bnr, char *string);
