
/* 
 * tclopto_DAC.c --
 *
 *  This file contains the top-level command routines for the
 *  the Kryo-specific built-in commands 
 *
 */

/*#include <stdlib.h>*/
#include <features.h>
#include <stddef.h>

/* Convert a string to an integer.  */
extern int atoi __P ((__const char *__nptr));

#include <time.h>
#include <rtlinux/rtl.h>
#include <rtlinux/rtl_time.h>
#include <rtlinux/arch/rtl_time.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/times.h>
#include <ctype.h>

#include "../realtime/rtl_pcl812pg/rtl_pcl812pg.h"

#include <tcl.h>

#define MIN(a,b)  (((a) < (b)) ? (a) : (b))

/* Prototypen */
char * Exp_Config_Dir();
double ValIn(char *input, char *unit);

/********************************************************************************
*																				*																			 																					 
*  	wdacstat:Erzeugt wenn noch nicht vorhanden eine Status und eine Protokoll-	*
*				  datei fr die DAC.											* 
*																				*																			 																					 
*	so gehts: wdacstat(dnumber,folge)											*
*	tnumber  = dacchannels														*
*	folge    = Ist i.a. der String der die DACfolge beschreibt: 				*
*																				*
*********************************************************************************/
void wdacstat(int dnumber, char *folge)
{
	char stpfad[100] =
	{""};				/* Statusausgabefile, die Kanalnummer wird noch angehaengt */
	char dumstr[100];
	
	FILE *stream;

	strcat(stpfad, Exp_Config_Dir());
	strcat(stpfad, "/params/dac.s");
	
	sprintf(dumstr, "%d", dnumber);
	strcat(stpfad, dumstr);		/* DACnr an Statusfile anhaengen */

	stream = fopen(stpfad, "w+");	/* Statusfile schreiben oeffnen */
	if (stream != NULL) {
		fprintf(stream, "%s\n", folge);
		fclose(stream);
	};
}

/*
 *----------------------------------------------------------------------
 *
 * Tcl_DAC --
 *
 *  See the user documentation for details on what it does.
 *
 * Results:
 *  A standard Tcl result.
 *
 * Side effects:
 *  See the user documentation.
 *
 *----------------------------------------------------------------------
 */

int Tcl_DACCmd(ClientData dummy, Tcl_Interp * interp, int argc, char **argv)
{
	size_t arglength;
	int	argindex;
	char argchar=0;
	
	int dacchannels, dacctl;
	char dacfolge[1000];
	double delay;
	double delaysum;
	
	struct rtl_pcl_msg dacmsg;
	
	char dacfifoname[10]="/dev/rtf", dacfifonumber[10];
	sprintf(dacfifonumber, "%d", PCL_FIFO);
	strcat(dacfifoname, dacfifonumber);

	/* Optionen parsen und aus dem Argumentfeld entfernen: */

	for (argindex = 1; argindex < argc;) {
		if (argv[argindex][0] == '-') {
			
			/* Hier die Optionen abfragen: */
			arglength = strlen(argv[argindex]);
			
			/*if (strncmp(argv[argindex], "-old", arglength)==0) {
				USE_OLD_PULSER = TRUE;
			} else {*/
				Tcl_AppendResult(interp, "ERROR: unknown option '", argv[argindex], "'\n", (char *) NULL);
				return TCL_ERROR;
			/*}*/

			/* Zeiger auf Argumente verschieben: */
			if (argindex < argc) {
				int i;
				for (i = argindex; i < argc; i++)
					argv[i] = argv[i + 1];
			}
			argc--;
		} else
			argindex++;
	}

	/* Argumentindex wieder auf den Beginn der Argumente setzen */
	argindex=1;

	/* Nun die Argumente parsen: */

	if (argc > 1) {
		argchar = argv[argindex][0];
		arglength = strlen(argv[argindex]);

		if (strlen(argv[argindex]) == 1 && isdigit(argv[argindex][0])) {
			goto dac_program;
			/* Falls erstes Argument eine einstellige Zahl ist ->  DAC programmieren */
			
/*** dac program ***/
		} else if (argchar == 'p' && strncmp(argv[argindex], "program", arglength) == 0) {
			argindex++;
			
dac_program:
			
			strcpy(dacfolge, "");
			dacfolge[0]=0;

			if (argc - argindex > 1) {

				if (strlen(argv[argindex]) == 1 && isdigit(argv[argindex][0])) {
					dacchannels = atoi(argv[argindex]);
					argindex++;

					if (dacchannels >=1 && dacchannels <= PCL_DAC_CHANNELS) {
						if ((dacctl = open(dacfifoname, O_WRONLY)) < 0) {
							Tcl_AppendResult(interp, "ERROR: can't open FIFO '", dacfifoname, "'\n", (char *) NULL);
							return TCL_ERROR;
						}
						
						dacmsg.channel = dacchannels-1;
						dacmsg.delay = 0;
						dacmsg.command = PCL_DAC_SEQUENCE_CLEAR;		
						if (write(dacctl, &dacmsg, sizeof(dacmsg)) < 0) {
							Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", dacfifoname, "'\n", (char *) NULL);
							close(dacctl);
							return TCL_ERROR;
						}
						
						delaysum=0;

						for (; argindex < argc; argindex++) {
							/* das DACereignis parsen: */
							if (strlen(argv[argindex]) == 1) {
								
							switch(argv[argindex][0]) {
									case 'l':
									case 'L':
										dacmsg.command = PCL_DAC_LEVEL_LOW;
										break;
										
									case 'h':
									case 'H':
										dacmsg.command = PCL_DAC_LEVEL_HIGH;
										break;
										
									case 'p':
									case 'P':
										dacmsg.command = PCL_DAC_LEVEL_PULSE;
										break;
							
									case 'n':
									case 'N':
										dacmsg.command = PCL_DAC_LEVEL_NOP;
										break;
										
									default:
										Tcl_AppendResult(interp, "ERROR: wrong dac-command '", argv[argindex], "'\n", (char *) NULL);
										close(dacctl);
										return TCL_ERROR;
								}
								strcat(dacfolge, argv[argindex]);
								
								strcat(dacfolge, " ");								
							} else {
								char unit[20];
								double dacval = ValIn(argv[argindex], unit);
								if (isnan(dacval)) {	
									Tcl_AppendResult(interp, "ERROR: wrong dac-command '", argv[argindex], "'\n", (char *) NULL);
									close(dacctl);
									return TCL_ERROR;
								}
								
								if (strlen(unit)==1 && unit[0]=='V') {
									dacval = dacval/PCL_DAC_ANALOGRANGE*PCL_DAC_RANGEMASK;
								}
								
								if (dacval<0 || dacval>PCL_DAC_RANGEMASK) {
									Tcl_AppendResult(interp, "ERROR: DAC-Value out of Range\n", (char *) NULL);
									close(dacctl);
									return TCL_ERROR;
								}
								
								dacmsg.command = (int)dacval;	
								strcat(dacfolge, argv[argindex]);
								
								strcat(dacfolge, " ");								
							}
							
							/* Dann die Delayzeit bestimmen: */
							
							argindex++;
							if (argindex < argc) {	
								char unit[50];
								
								delay = ValIn(argv[argindex], unit);
								if (isnan(delay) || delay < 0.000009) {
									Tcl_AppendResult(interp, "ERROR: wrong delaytime '", argv[argindex], "'\n", (char *) NULL);
									dacmsg.delay = 0;
									close(dacctl);
									return TCL_ERROR;
								}
								dacmsg.delay =  (HRTICKS_PER_SEC * (delaysum + delay)) - \
												(HRTICKS_PER_SEC * delaysum);
								delaysum += delay;

								sprintf(unit,"%.3f",delay);
								strcat(dacfolge, unit);
								strcat(dacfolge, " ");
							} else {
								dacmsg.delay = 0;
							}
							
							/* Nun das DACkommando absetzen */
						
							if (write(dacctl, &dacmsg, sizeof(dacmsg)) < 0) {
								Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", dacfifoname, "'\n", (char *) NULL);
								close(dacctl);
								return TCL_ERROR;
							}
						}
								
						if (close(dacctl) < 0) {
							Tcl_AppendResult(interp, "ERROR: can't close FIFO '", dacfifoname, "'\n", (char *) NULL);
							return TCL_ERROR;
						}
						
						/* Das Statusfile schreiben */
						wdacstat(dacchannels,dacfolge);

					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <dac#>\n", (char *) NULL);
						return TCL_ERROR;
					}
					return TCL_OK;
				}
			}
			Tcl_AppendResult(interp, " USAGE: \"dac <dac#> <dacevent> [<delay> [<dacevent>] ...]\"\n",
									 "        \"dac program <dac#> <dacevent> [<delay> [<dacevent>] ...]\"\n\n",
							 " <dac#>  = 1-8, ist die Nummer des DACausgangs\n",
							 " <dacevent>  = \'l\' Pegel low, \'h\' Pegel high, \'p\' Puls ausgeben, \'n\' NOP \n",
							 " <delay>     = Wartezeit zwischen den einzelnen <dacevent>\n",
							 "               z. B. \'1\' (= 1 s), \'10m\' (= 10 ms)\n",
							 "         Falls die letze Angabe in der Befehlszeile ein <delay>-Wert ist wird\n",
							 "         die DACsequenz periodisch ausgefhrt, dieser <delay>-Wert ist\n", 
							 "         dann die Wartezeit bis zum erneuten Beginn der DACsequenz\n", (char *) NULL);
			return TCL_ERROR;

/*** dac set ***/
		} else if (argchar == 's' && strncmp(argv[argindex], "set", arglength) == 0) {
		
			if (argindex == argc-3) {	
				char unit[50];
				char dacresult[10];
				double dacval=0;
				
				argindex++;
				if (sscanf(argv[argindex], "%i", &dacchannels)==1) {
					
					argindex++;
					dacval = ValIn(argv[argindex], unit);

					if (isnan(dacval)) {
						Tcl_AppendResult(interp, "ERROR: Wrong DAC-Value \'", argv[argindex], "\'\n", (char *) NULL);
						return TCL_ERROR;
					}
					
					if (strlen(unit)==1 && unit[0]=='V') {
						dacval = dacval/PCL_DAC_ANALOGRANGE*PCL_DAC_RANGEMASK;
					}
					
					if (dacval<0 || dacval>PCL_DAC_RANGEMASK) {
						Tcl_AppendResult(interp, "ERROR: DAC-Value out of Range\n", (char *) NULL);
						return TCL_ERROR;
					}
							
					if (dacchannels < 1 || dacchannels > PCL_DAC_CHANNELS) {
						Tcl_AppendResult(interp, "ERROR: wrong DAC#\n", (char *) NULL);
						return TCL_ERROR;
					}
					
					/* Zuerst die DAC Kommando FIFO oeffnen */

					if ((dacctl = open(dacfifoname, O_WRONLY)) < 0) {
						Tcl_AppendResult(interp, "ERROR: can't open FIFO '", dacfifoname, "'\n", (char *) NULL);
						return TCL_ERROR;
					}

					dacmsg.channel = dacchannels-1;
					dacmsg.command = PCL_DAC_SET;
					dacmsg.endvalue = (int)dacval;
					
					if (write(dacctl, &dacmsg, sizeof(dacmsg)) < 0) {
						Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", dacfifoname, "'\n", (char *) NULL);
						close(dacctl);
						return TCL_ERROR;
				}
					
					if (close(dacctl) < 0) {
						Tcl_AppendResult(interp, "ERROR: can't close FIFO '", dacfifoname, "'\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
				sprintf(dacresult, "0x%03x", (int)dacval);
				Tcl_AppendResult(interp, dacresult, (char *) NULL);
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: dac set <dac#> <Value>[<Unit>]\n", (char *) NULL);
			return TCL_ERROR;

/*** dac start **/
		} else if (argchar == 's' && strncmp(argv[argindex], "start", arglength) == 0) {
		
			if (argindex < argc-1) {	
				int startbits=0;
				
				for(argindex++; argindex < argc; argindex++) {
					sscanf(argv[argindex], "%i", &dacchannels);
					
					if (dacchannels >=1 && dacchannels <= PCL_DAC_CHANNELS) {
						startbits |= (1 << (dacchannels-1));
					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <dac#>\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
						
				/* Zuerst die DAC Kommando FIFO oeffnen */

				if ((dacctl = open(dacfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", dacfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				dacmsg.command = PCL_DAC_SEQUENCE_START;
				dacmsg.delay = 0;
				dacmsg.channel = startbits;
				if (write(dacctl, &dacmsg, sizeof(dacmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", dacfifoname, "'\n", (char *) NULL);
					close(dacctl);
					return TCL_ERROR;
				}
				
				if (close(dacctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", dacfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: dac start <dac#> [<dac#> ... ]\n", (char *) NULL);
			return TCL_ERROR;

/*** dac stop ***/
		} else if (argchar == 's' && strncmp(argv[argindex], "stop", arglength) == 0) {

			if (argindex < argc-1) {	
				int startbits=0;
				
				for(argindex++; argindex < argc; argindex++) {
					sscanf(argv[argindex], "%i", &dacchannels);
					
					if (dacchannels >= 1 && dacchannels <= PCL_DAC_CHANNELS) {
						startbits |= (1 << (dacchannels-1));
					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <dac#>\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
						
				/* Zuerst die DAC Kommando FIFO oeffnen */

				if ((dacctl = open(dacfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", dacfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				dacmsg.command = PCL_DAC_SEQUENCE_STOP;
				dacmsg.delay = 0;
				dacmsg.channel = startbits;
				
				if (write(dacctl, &dacmsg, sizeof(dacmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", dacfifoname, "'\n", (char *) NULL);
					close(dacctl);
					return TCL_ERROR;
				}
				
				if (close(dacctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", dacfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: dac stop <dac#> [<dac#> ... ]\n", (char *) NULL);
			return TCL_ERROR;
			
/*** dac sweep ***/
		} else if (argchar == 's' && strncmp(argv[argindex], "sweep", arglength) == 0) {
		
			if (argindex == argc-4) {	
				char unit[20];
				char dacresult[10];
				double dacstopval=0;
				double dacsweeptime=0;
				
				argindex++;
				if (sscanf(argv[argindex], "%i", &dacchannels)==1) {
					
					argindex++;
					dacstopval = ValIn(argv[argindex], unit);
					if (isnan(dacstopval)) {
						Tcl_AppendResult(interp, "ERROR: Wrong DAC-Value \'", argv[argindex], "\'\n", (char *) NULL);
						return TCL_ERROR;
					}
					
					if (strlen(unit)==1 && unit[0]=='V') {
						dacstopval = dacstopval/PCL_DAC_ANALOGRANGE*PCL_DAC_RANGEMASK;
					}
					if (dacstopval<0 || dacstopval>PCL_DAC_RANGEMASK) {
						Tcl_AppendResult(interp, "ERROR: DAC-Value out of Range\n", (char *) NULL);
						return TCL_ERROR;
					}
					
					argindex++;
					dacsweeptime = ValIn(argv[argindex], unit);
					if (isnan(dacsweeptime)) {
						Tcl_AppendResult(interp, "ERROR: Wrong Sweeptime-Value \'", argv[argindex], "\'\n", (char *) NULL);
						return TCL_ERROR;
					}
					
					/* Zuerst die DAC Kommando FIFO oeffnen */
					
					if (dacchannels < 1 || dacchannels >PCL_DAC_CHANNELS) {
						Tcl_AppendResult(interp, "ERROR: wrong DAC#\n", (char *) NULL);
						return TCL_ERROR;
					}

					if ((dacctl = open(dacfifoname, O_WRONLY)) < 0) {
						Tcl_AppendResult(interp, "ERROR: can't open FIFO '", dacfifoname, "'\n", (char *) NULL);
						return TCL_ERROR;
					}
					
					dacmsg.channel = dacchannels-1;
					dacmsg.command = PCL_DAC_SWEEP;
					dacmsg.endvalue = (int)dacstopval;
					dacmsg.delay = (hrtime_t)(dacsweeptime*HRTICKS_PER_SEC);
					
					if (write(dacctl, &dacmsg, sizeof(dacmsg)) < 0) {
						Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", dacfifoname, "'\n", (char *) NULL);
						close(dacctl);
						return TCL_ERROR;
					} 
					
					if (close(dacctl) < 0) {
						Tcl_AppendResult(interp, "ERROR: can't close FIFO '", dacfifoname, "'\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
				sprintf(dacresult, "-> 0x%03x", (int)dacstopval);
				Tcl_AppendResult(interp, dacresult, (char *) NULL);
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: dac set <dac#> <Value>[<Unit>]\n", (char *) NULL);
			return TCL_ERROR;

/*** unbekannter Befehl: ***/
		} else {
			goto DAC_Help;
		}
	} else {
DAC_Help:

		Tcl_AppendResult(interp, "\nusage: dac [flags] <command> [options]\n\n",
			   					 "  [flags]:    '-old'\t use old rf-dac\n\n",
							 	 "  <command>:  'program <dac#> <...>' or\n",
								 "              '<dac#> <...>'             program dacsequence <dac#> \n",
								 "              'start <dac#>              start dac sequence <dac#>\n\n"
								 "              'stop <dac#>               stop dac sequence <dac#>\n\n"
								 "  use 'dac <command>' for more info!\n", (char *) NULL);
		return TCL_ERROR;
	}
	return TCL_ERROR;
}


/********************************************************************************
*																				*																			 																					 
*  	wdoutstat:Erzeugt wenn noch nicht vorhanden eine Status und eine Protokoll- *
*			  datei f|r die dout.												* 
*																				*																			 																					 
*	so gehts: wdoutstat(tnumber,folge)											*
*	tnumber  = doutbit (1-8)													*
*	folge    = Ist i.a. der String der die doutfolge beschreibt: 				*
*																				*
*********************************************************************************/
void wdoutstat(int tnumber, char *folge)
{
	char stpfad[100] =
	{""};				/* Statusausgabefile, die Kanalnummer wird noch angehaengt */
	char dumstr[100];
	
	FILE *stream;

	strcat(stpfad, Exp_Config_Dir());
	strcat(stpfad, "/params/dout.s");
	
	sprintf(dumstr, "%d", tnumber);
	strcat(stpfad, dumstr);		/* doutnr an Statusfile anhaengen */

	stream = fopen(stpfad, "w+");	/* Statusfile schreiben oeffnen */
	if (stream != NULL) {
		fprintf(stream, "%s\n", folge);
		fclose(stream);
	};
}

/*
 *----------------------------------------------------------------------
 *
 * Tcl_Dout --
 *
 *  See the user documentation for details on what it does.
 *
 * Results:
 *  A standard Tcl result.
 *
 * Side effects:
 *  See the user documentation.
 *
 *----------------------------------------------------------------------
 */

int Tcl_DoutCmd(ClientData dummy, Tcl_Interp * interp, int argc, char **argv)
{
	size_t arglength;
	int	argindex;
	char argchar=0;
	
	int doutbit, doutctl;
	char doutfolge[1000];
	double delay;
	double delaysum;
	
	struct rtl_pcl_msg doutmsg;
	
	char doutfifoname[10]="/dev/rtf", doutfifonumber[10];
	sprintf(doutfifonumber, "%d", PCL_FIFO);
	strcat(doutfifoname, doutfifonumber);
						
	
	/* Optionen parsen und aus dem Argumentfeld entfernen: */

	for (argindex = 1; argindex < argc;) {
		if (argv[argindex][0] == '-') {
			
			/* Hier die Optionen abfragen: */
			arglength = strlen(argv[argindex]);
			
			/*if (strncmp(argv[argindex], "-old", arglength)==0) {
				USE_OLD_PULSER = TRUE;
			} else {*/
				Tcl_AppendResult(interp, "ERROR: unknown option '", argv[argindex], "'\n", (char *) NULL);
				return TCL_ERROR;
			/*}*/

			/* Zeiger auf Argumente verschieben: */
			if (argindex < argc) {
				int i;
				for (i = argindex; i < argc; i++)
					argv[i] = argv[i + 1];
			}
			argc--;
		} else
			argindex++;
	}

	/* Argumentindex wieder auf den Beginn der Argumente setzen */
	argindex=1;

	/* Nun die Argumente parsen: */

	if (argc > 1) {
		argchar = argv[argindex][0];
		arglength = strlen(argv[argindex]);

		if (strlen(argv[argindex]) == 1 && isdigit(argv[argindex][0])) {
			goto dout_program;
			/* Falls erstes Argument eine einstellige Zahl ist ->  dout programmieren */
			
/*** dout clear ***/
		} else if (argchar == 'c' && strncmp(argv[argindex], "clear", arglength) == 0) {
		
			if (argindex < argc-1) {	
				int clearbits=0;
				
				for(argindex++; argindex < argc; argindex++) {
					sscanf(argv[argindex], "%i", &doutbit);
					
					if (doutbit >=1 && doutbit <= PCL_DO_BITS) {
						wdoutstat(doutbit,"l");
						clearbits |= (1 << (doutbit-1));
					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <dout#>\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
						
				/* Zuerst die dout Kommando FIFO oeffnen */

				if ((doutctl = open(doutfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", doutfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				doutmsg.command = PCL_DO_CLEAR;
				doutmsg.delay = 0;
				doutmsg.channel = clearbits;
				if (write(doutctl, &doutmsg, sizeof(doutmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", doutfifoname, "'\n", (char *) NULL);
					close(doutctl);
					return TCL_ERROR;
				}
				
				if (close(doutctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", doutfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: dout clear <dout#> [<dout#> ... ]\n", (char *) NULL);
			return TCL_ERROR;

/*** dout program ***/
		} else if (argchar == 'p' && strncmp(argv[argindex], "program", arglength) == 0) {
			argindex++;
			
			strcpy(doutfolge, "");
			
			
dout_program:

			//		printf("doutfolge : %s\n", doutfolge);
			
			if (argc - argindex > 1) {

				if (strlen(argv[argindex]) == 1 && isdigit(argv[argindex][0])) {
					doutbit = atoi(argv[argindex]);
					argindex++;

					if (doutbit >=1 && doutbit <= PCL_DO_BITS) {
						if ((doutctl = open(doutfifoname, O_WRONLY)) < 0) {
							Tcl_AppendResult(interp, "ERROR: can't open FIFO '", doutfifoname, "'\n", (char *) NULL);
							return TCL_ERROR;
						}

						doutmsg.channel = doutbit-1;
						doutmsg.delay = 0;
						doutmsg.command = PCL_DO_SEQUENCE_CLEAR;		
						if (write(doutctl, &doutmsg, sizeof(doutmsg)) < 0) {
							Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", doutfifoname, "'\n", (char *) NULL);
							close(doutctl);
							return TCL_ERROR;
						}
						
						delaysum=0;

						for (; argindex < argc; argindex++) {
							/* das doutereignis parsen: */
							if (strlen(argv[argindex]) == 1) {
								
								switch(argv[argindex][0]) {
									case 'l':
									case 'L':
										doutmsg.command = PCL_DO_LEVEL_LOW;
										break;
										
									case 'h':
									case 'H':
										doutmsg.command = PCL_DO_LEVEL_HIGH;
										break;
										
									case 'p':
									case 'P':
										doutmsg.command = PCL_DO_LEVEL_PULSE;
										break;
							
									case 'n':
									case 'N':
										doutmsg.command = PCL_DO_LEVEL_NOP;
										break;
										
									default:
										Tcl_AppendResult(interp, "ERROR: wrong dout-command '", argv[argindex], "'\n", (char *) NULL);
										return TCL_ERROR;
								}
								strcat(doutfolge, argv[argindex]);
								
								strcat(doutfolge, " ");								
							} else {
								Tcl_AppendResult(interp, "ERROR: wrong dout-command '", argv[argindex], "'\n", (char *) NULL);
								close(doutctl);
								return TCL_ERROR;
							}
							
							/* Dann die Delayzeit bestimmen: */
							
							argindex++;
							if (argindex < argc) {	
								char unit[50];
								
								delay = ValIn(argv[argindex], unit);
								doutmsg.delay = (HRTICKS_PER_SEC * (delaysum + delay)) - \
												(HRTICKS_PER_SEC * delaysum);
								delaysum += delay;

								if (delay < 0.000009) {
									Tcl_AppendResult(interp, "ERROR: wrong delaytime '", argv[argindex], "'\n", (char *) NULL);
									doutmsg.delay = 0;
								}
								sprintf(unit,"%.3f",delay);
								strcat(doutfolge, unit);
								strcat(doutfolge, " ");
							} else {
								doutmsg.delay = 0;
							}
							
							/* Nun das doutkommando absetzen */
							
							if (write(doutctl, &doutmsg, sizeof(doutmsg)) < 0) {
								Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", doutfifoname, "'\n", (char *) NULL);
								close(doutctl);
								return TCL_ERROR;
							}
						}
								
						if (close(doutctl) < 0) {
							Tcl_AppendResult(interp, "ERROR: can't close FIFO '", doutfifoname, "'\n", (char *) NULL);
							return TCL_ERROR;
						}
						
						/* Das Statusfile schreiben */
						wdoutstat(doutbit,doutfolge);

					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <dout#>\n", (char *) NULL);
						return TCL_ERROR;
					}
					return TCL_OK;
				}
			}
			Tcl_AppendResult(interp, " USAGE: \"dout <dout#> <trgevent> [<delay> [<trgevent>] ...]\"\n",
									 "        \"dout program <dout#> <trgevent> [<delay> [<trgevent>] ...]\"\n\n",
							 " <dout#>  = 1-8, ist die Nummer des doutausgangs\n",
							 " <trgevent>  = \'l\' Pegel low, \'h\' Pegel high, \'p\' Puls ausgeben, \'n\' NOP \n",
							 " <delay>     = Wartezeit zwischen den einzelnen <trgevent>\n",
							 "               z. B. \'1\' (= 1 s), \'10m\' (= 10 ms)\n",
							 "         Falls die letze Angabe in der Befehlszeile ein <delay>-Wert ist wird\n",
							 "         die doutsequenz periodisch ausgefhrt, dieser <delay>-Wert ist\n", 
							 "         dann die Wartezeit bis zum erneuten Beginn der doutsequenz\n", (char *) NULL);
			return TCL_ERROR;

/*** dout set ***/
		} else if (argchar == 's' && strncmp(argv[argindex], "set", arglength) == 0) {
		
			if (argindex < argc-1) {	
				int setbits=0;
				
				for(argindex++; argindex < argc; argindex++) {
					sscanf(argv[argindex], "%i", &doutbit);
					
					if (doutbit >=1 && doutbit <= PCL_DO_BITS) {
						wdoutstat(doutbit,"h");
						setbits |= (1 << (doutbit-1));
					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <dout#>\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
						
				/* Zuerst die dout Kommando FIFO oeffnen */

				if ((doutctl = open(doutfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", doutfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				doutmsg.command = PCL_DO_SET;
				doutmsg.channel = setbits;
				
				if (write(doutctl, &doutmsg, sizeof(doutmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", doutfifoname, "'\n", (char *) NULL);
					close(doutctl);
					return TCL_ERROR;
				}
				
				if (close(doutctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", doutfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: dout set <dout#> [<dout#> ... ]\n", (char *) NULL);
			return TCL_ERROR;

/*** dout start ***/
		} else if (argchar == 's' && strncmp(argv[argindex], "start", arglength) == 0) {
		
			if (argindex < argc-1) {	
				int startbits=0;
				
				for(argindex++; argindex < argc; argindex++) {
					if (sscanf(argv[argindex], "%i", &doutbit) != 1) {
						Tcl_AppendResult(interp, "ERROR: syntax error in <dout#>\n", (char *) NULL);
						return TCL_ERROR;
					}
					
					if (doutbit >=1 && doutbit <= PCL_DO_BITS) {
						startbits |= (1 << (doutbit-1));
					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <dout#>\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
						
				/* Zuerst die dout Kommando FIFO oeffnen */

				if ((doutctl = open(doutfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", doutfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				doutmsg.command = PCL_DO_SEQUENCE_START;
				doutmsg.channel = startbits;
				
				if (write(doutctl, &doutmsg, sizeof(doutmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", doutfifoname, "'\n", (char *) NULL);
					close(doutctl);
					return TCL_ERROR;
				}
				
				if (close(doutctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", doutfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: dout start <dout#> [<dout#> ... ]\n", (char *) NULL);
			return TCL_ERROR;

/*** dout stop ***/
		} else if (argchar == 's' && strncmp(argv[argindex], "stop", arglength) == 0) {

			if (argindex < argc-1) {	
				int stopbits=0;
				
				for(argindex++; argindex < argc; argindex++) {
					sscanf(argv[argindex], "%i", &doutbit);
					
					if (doutbit >=1 && doutbit <= PCL_DO_BITS) {
						stopbits |= (1 << (doutbit-1));
					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <dout#>\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
						
				/* Zuerst die dout Kommando FIFO oeffnen */

				if ((doutctl = open(doutfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", doutfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				doutmsg.command = PCL_DO_SEQUENCE_STOP;
				doutmsg.channel = stopbits;
				if (write(doutctl, &doutmsg, sizeof(doutmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", doutfifoname, "'\n", (char *) NULL);
					close(doutctl);
					return TCL_ERROR;
				}
				
				if (close(doutctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", doutfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: dout stop <dout#> [<dout#> ... ]\n", (char *) NULL);
			return TCL_ERROR;
			
/*** unbekannter Befehl: ***/
		} else {
			goto dout_Help;
		}
	} else {
dout_Help:

		Tcl_AppendResult(interp, "\nusage: dout [flags] <command> [options]\n\n",
			   					 "  [flags]:    '-old'\t use old rf-dout\n\n",
							 	 "  <command>:  'program <dout#> <...>' or\n",
								 "              '<dout#> <...>'             program doutsequence <dout#> \n",
								 "              'start <dout#>              start dout sequence <dout#>\n\n"
								 "              'stop <dout#>               stop dout sequence <dout#>\n\n"
								 "  use 'dout <command>' for more info!\n", (char *) NULL);
		return TCL_ERROR;
	}
	return TCL_ERROR;
}

/*
 *----------------------------------------------------------------------
 *
 * Tcl_ADC --
 *
 *  See the user documentation for details on what it does.
 *
 * Results:
 *  A standard Tcl result.
 *
 * Side effects:
 *  See the user documentation.
 *
 *----------------------------------------------------------------------
 */

int Tcl_ADCCmd(ClientData dummy, Tcl_Interp * interp, int argc, char **argv)
{
	size_t arglength;
	int	argindex;
	char argchar=0;
	
	int adcchannel, adcctl;
	int adcvalue=0;
	char result[30];
				
	
	struct rtl_pcl_msg adcmsg;
	
	char adcfifoname[10]="/dev/rtf", adcfifonumber[10];
	sprintf(adcfifonumber, "%d", PCL_FIFO);
	strcat(adcfifoname, adcfifonumber);
						
	
	/* Optionen parsen und aus dem Argumentfeld entfernen: */

	for (argindex = 1; argindex < argc;) {
		if (argv[argindex][0] == '-') {
			
			/* Hier die Optionen abfragen: */
			arglength = strlen(argv[argindex]);
			
			/*if (strncmp(argv[argindex], "-old", arglength)==0) {
				USE_OLD_PULSER = TRUE;
			} else {*/
				Tcl_AppendResult(interp, "ERROR: unknown option '", argv[argindex], "'\n", (char *) NULL);
				return TCL_ERROR;
			/*}*/

			/* Zeiger auf Argumente verschieben: */
			if (argindex < argc) {
				int i;
				for (i = argindex; i < argc; i++)
					argv[i] = argv[i + 1];
			}
			argc--;
		} else
			argindex++;
	}

	/* Argumentindex wieder auf den Beginn der Argumente setzen */
	argindex=1;

	/* Nun die Argumente parsen: */

	if (argc > 1) {
		argchar = argv[argindex][0];
		arglength = strlen(argv[argindex]);

/*** adc read ***/
		if (argchar == 'r' && strncmp(argv[argindex], "read", arglength) == 0) {
		
			if (argindex < argc-1) {
				argindex++;
				
				if (sscanf(argv[argindex], "%i", &adcchannel) != 1) {
					Tcl_AppendResult(interp, "ERROR: syntax error in <adc#>\n", (char *) NULL);
					return TCL_ERROR;
				}
					
				if (adcchannel >=1 && adcchannel <= PCL_ADC_CHANNELS) {
					adcmsg.channel = adcchannel-1;
				} else {
					Tcl_AppendResult(interp, "ERROR: wrong <adc#>\n", (char *) NULL);
					return TCL_ERROR;
				}
						
				/* Zuerst die adc Kommando FIFO oeffnen */

				if ((adcctl = open(adcfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", adcfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				adcmsg.command = PCL_ADC_READ;
				adcmsg.endvalue = (int)&adcvalue;
				
				if (write(adcctl, &adcmsg, sizeof(adcmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", adcfifoname, "'\n", (char *) NULL);
					close(adcctl);
					return TCL_ERROR;
				}
				
				if (close(adcctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", adcfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				
				sprintf(result,"%f",(20.0*adcvalue/PCL_ADC_RANGE)-10.0);
				Tcl_AppendResult(interp, result, (char *) NULL);
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: adc start <adc#> [<adc#> ... ]\n", (char *) NULL);
			return TCL_ERROR;
			
/*** unbekannter Befehl: ***/
		} else {
			goto adc_Help;
		}
	} else {
		
adc_Help:

		Tcl_AppendResult(interp, "\nusage: adc [flags] <command> [options]\n\n",
			   					 "  [flags]:    '-old'\t use old rf-adc\n\n",
							 	 "  <command>:  'program <adc#> <...>' or\n",
								 "              '<adc#> <...>'             program adcsequence <adc#> \n",
								 "              'start <adc#>              start adc sequence <adc#>\n\n"
								 "              'stop <adc#>               stop adc sequence <adc#>\n\n"
								 "  use 'adc <command>' for more info!\n", (char *) NULL);
		return TCL_ERROR;
	}
	return TCL_ERROR;
}
