/* 
 * tclopto_parport.c --
 *
 *  This file contains the top-level command routines for the
 *  the Kryo-spezific built-in commands 
 *
 * Copyright (c) 1987-1993 The Regents of the University of California.
 * Copyright (c) 1994-1995 Sun Microsystems, Inc.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file, and for a DISCLAIMER OF ALL WARRANTIES.
 */

/*#include <stdlib.h>*/
#include <features.h>
#include <stddef.h>
/* Convert a string to an integer.  */
extern int atoi __P ((__const char *__nptr));


#include <time.h>
#include <rtlinux/rtl.h>
#include <rtlinux/rtl_time.h>
#include <rtlinux/arch/rtl_time.h>
#include <string.h>
#include <math.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/times.h>
#include <ctype.h>


#include "../realtime/rtl_parport/rtl_parport.h"

#include <tcl.h>

#define MIN(a,b)  (((a) < (b)) ? (a) : (b))

/* Prototypen */
char * Exp_Config_Dir();
double ValIn(char *input, char *unit);

/********************************************************************************
*																				*																			 																					 
*  	wpulsstat:Erzeugt wenn noch nicht vorhanden eine Status und eine Protokoll- *
*			  datei f|r die parport.											* 
*																				*																			 																					 
*	so gehts: wparportstat(tnumber,folge)											*
*	tnumber  = parportbit (1-8)												*
*	folge    = Ist i.a. der String der die parportfolge beschreibt: 			*
*																				*
*********************************************************************************/
void wparportstat(int tnumber, char *folge)
{
	char stpfad[100] =
	{""};				/* Statusausgabefile, die Kanalnummer wird noch angehaengt */
	char dumstr[100];
	
	FILE *stream;

	strcat(stpfad, Exp_Config_Dir());
	strcat(stpfad, "/params/parport.s");
	
	sprintf(dumstr, "%d", tnumber);
	strcat(stpfad, dumstr);		/* parportnr an Statusfile anhaengen */

	stream = fopen(stpfad, "w+");	/* Statusfile schreiben oeffnen */
	if (stream != NULL) {
		fprintf(stream, "%s\n", folge);
		fclose(stream);
	};
}

/*
 *----------------------------------------------------------------------
 *
 * Tcl_parport --
 *
 *  See the user documentation for details on what it does.
 *
 * Results:
 *  A standard Tcl result.
 *
 * Side effects:
 *  See the user documentation.
 *
 *----------------------------------------------------------------------
 */

int Tcl_ParportCmd(ClientData dummy, Tcl_Interp * interp, int argc, char **argv)
{
	size_t arglength;
	int	argindex;
	char argchar=0;
	
	int parportbit, parportctl;
	char parportfolge[1000];
	double delay;
	double delaysum;
	
	struct rtl_parport_msg parportmsg;
	
	char parportfifoname[10]="/dev/rtf", parportfifonumber[10];
	sprintf(parportfifonumber, "%d", PARPORT_FIFO);
	strcat(parportfifoname, parportfifonumber);
					
	/* Optionen parsen und aus dem Argumentfeld entfernen: */

	for (argindex = 1; argindex < argc;) {
		if (argv[argindex][0] == '-') {
			
			/* Hier die Optionen abfragen: */
			arglength = strlen(argv[argindex]);
			
			/*if (strncmp(argv[argindex], "-old", arglength)==0) {
				USE_OLD_PULSER = TRUE;
			} else {*/
				Tcl_AppendResult(interp, "ERROR: unknown option '", argv[argindex], "'\n", (char *) NULL);
				return TCL_ERROR;
			/*}*/

			/* Zeiger auf Argumente verschieben: */
			if (argindex < argc) {
				int i;
				for (i = argindex; i < argc; i++)
					argv[i] = argv[i + 1];
			}
			argc--;
		} else
			argindex++;
	}

	/* Argumentindex wieder auf den Beginn der Argumente setzen */
	argindex=1;

	/* Nun die Argumente parsen: */

	if (argc > 1) {
		argchar = argv[argindex][0];
		arglength = strlen(argv[argindex]);

		if (strlen(argv[argindex]) == 1 && isdigit(argv[argindex][0])) {
			goto parport_program;
			/* Falls erstes Argument eine einstellige Zahl ist ->  parport programmieren */
			
/*** parport clear ***/
		} else if (argchar == 'c' && strncmp(argv[argindex], "clear", arglength) == 0) {
		
			if (argindex < argc-1) {	
				int clearbits=0;
				
				for(argindex++; argindex < argc; argindex++) {
					sscanf(argv[argindex], "%i", &parportbit);
					
					if (parportbit >=1 && parportbit <=8) {
						clearbits |= (1 << (parportbit-1));
					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <parport#>\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
						
				/* Zuerst die parport Kommando FIFO oeffnen */

				if ((parportctl = open(parportfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", parportfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				parportmsg.command = PARPORT_CLEAR;
				parportmsg.bit = clearbits;
				if (write(parportctl, &parportmsg, sizeof(parportmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", parportfifoname, "'\n", (char *) NULL);
					close(parportctl);
					return TCL_ERROR;
				}
				
				if (close(parportctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", parportfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: parport start <parport#> [<parport#> ... ]\n", (char *) NULL);
			return TCL_ERROR;

/*** parport program ***/
		} else if (argchar == 'p' && strncmp(argv[argindex], "program", arglength) == 0) {
			argindex++;
			
			strcpy(parportfolge, "");
			
			
parport_program:

			//		printf("parportfolge : %s\n", parportfolge);
			
			if (argc - argindex > 1) {

				if (strlen(argv[argindex]) == 1 && isdigit(argv[argindex][0])) {
					parportbit = atoi(argv[argindex]);
					argindex++;

					if (parportbit >=1 && parportbit <=8) {
						if ((parportctl = open(parportfifoname, O_WRONLY)) < 0) {
							Tcl_AppendResult(interp, "ERROR: can't open FIFO '", parportfifoname, "'\n", (char *) NULL);
							return TCL_ERROR;
						}

						parportmsg.bit = parportbit-1;
						parportmsg.command = PARPORT_SEQUENCE_CLEAR;		
						if (write(parportctl, &parportmsg, sizeof(parportmsg)) < 0) {
							Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", parportfifoname, "'\n", (char *) NULL);
							close(parportctl);
							return TCL_ERROR;
						}
						
						delaysum=0;

						for (; argindex < argc; argindex++) {
							/* das parportereignis parsen: */
							if (strlen(argv[argindex]) == 1) {
								
								switch(argv[argindex][0]) {
									case 'l':
									case 'L':
										parportmsg.command = PARPORT_LEVEL_LOW;
										break;
										
									case 'h':
									case 'H':
										parportmsg.command = PARPORT_LEVEL_HIGH;
										break;
										
									case 'p':
									case 'P':
										parportmsg.command = PARPORT_LEVEL_PULSE;
										break;
							
									case 'n':
									case 'N':
										parportmsg.command = PARPORT_LEVEL_NOP;
										break;
										
									default:
										Tcl_AppendResult(interp, "ERROR: wrong parport-command '", argv[argindex], "'\n", (char *) NULL);
										return TCL_ERROR;
								}
								strcat(parportfolge, argv[argindex]);
								
								strcat(parportfolge, " ");								
							} else {
								Tcl_AppendResult(interp, "ERROR: wrong parport-command '", argv[argindex], "'\n", (char *) NULL);
								close(parportctl);
								return TCL_ERROR;
							}
							
							/* Dann die Delayzeit bestimmen: */
							
							argindex++;
							if (argindex < argc) {	
								char unit[50];
								
								delay = ValIn(argv[argindex], unit);
								parportmsg.delay = (HRTICKS_PER_SEC * (delaysum + delay)) - \
												   (HRTICKS_PER_SEC * delaysum);
								delaysum += delay;

								if (delay < 0.00005) {
									Tcl_AppendResult(interp, "ERROR: wrong delaytime '", argv[argindex], "'\n", (char *) NULL);
									parportmsg.delay = 0;
								}
								sprintf(unit,"%.3f",delay);
								strcat(parportfolge, unit);
								strcat(parportfolge, " ");
							} else {
								parportmsg.delay = 0;
							}
							
							/* Nun das parportkommando absetzen */
							
							if (write(parportctl, &parportmsg, sizeof(parportmsg)) < 0) {
								Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", parportfifoname, "'\n", (char *) NULL);
								close(parportctl);
								return TCL_ERROR;
							}
						}
								
						if (close(parportctl) < 0) {
							Tcl_AppendResult(interp, "ERROR: can't close FIFO '", parportfifoname, "'\n", (char *) NULL);
							return TCL_ERROR;
						}
						
						/* Das Statusfile schreiben */
						wparportstat(parportbit,parportfolge);

					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <parport#>\n", (char *) NULL);
						return TCL_ERROR;
					}
					return TCL_OK;
				}
			}
			Tcl_AppendResult(interp, " USAGE: \"parport <parport#> <trgevent> [<delay> [<trgevent>] ...]\"\n",
									 "        \"parport program <parport#> <trgevent> [<delay> [<trgevent>] ...]\"\n\n",
							 " <parport#>  = 1-8, ist die Nummer des parportausgangs\n",
							 " <trgevent>  = \'l\' Pegel low, \'h\' Pegel high, \'p\' Puls ausgeben, \'n\' NOP \n",
							 " <delay>     = Wartezeit zwischen den einzelnen <trgevent>\n",
							 "               z. B. \'1\' (= 1 s), \'10m\' (= 10 ms)\n",
							 "         Falls die letze Angabe in der Befehlszeile ein <delay>-Wert ist wird\n",
							 "         die parportsequenz periodisch ausgefhrt, dieser <delay>-Wert ist\n", 
							 "         dann die Wartezeit bis zum erneuten Beginn der parportsequenz\n", (char *) NULL);
			return TCL_ERROR;

/*** parport set ***/
		} else if (argchar == 's' && strncmp(argv[argindex], "set", arglength) == 0) {
		
			if (argindex < argc-1) {	
				int setbits=0;
				
				for(argindex++; argindex < argc; argindex++) {
					sscanf(argv[argindex], "%i", &parportbit);
					
					if (parportbit >=1 && parportbit <=8) {
						setbits |= (1 << (parportbit-1));
					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <parport#>\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
						
				/* Zuerst die parport Kommando FIFO oeffnen */

				if ((parportctl = open(parportfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", parportfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				parportmsg.command = PARPORT_SET;
				parportmsg.bit = setbits;
				if (write(parportctl, &parportmsg, sizeof(parportmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", parportfifoname, "'\n", (char *) NULL);
					close(parportctl);
					return TCL_ERROR;
				}
				
				if (close(parportctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", parportfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: parport start <parport#> [<parport#> ... ]\n", (char *) NULL);
			return TCL_ERROR;

/*** parport start ***/
		} else if (argchar == 's' && strncmp(argv[argindex], "start", arglength) == 0) {
		
			if (argindex < argc-1) {	
				int startbits=0;
				
				for(argindex++; argindex < argc; argindex++) {
					sscanf(argv[argindex], "%i", &parportbit);
					
					if (parportbit >=1 && parportbit <=8) {
						startbits |= (1 << (parportbit-1));
					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <parport#>\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
						
				/* Zuerst die parport Kommando FIFO oeffnen */

				if ((parportctl = open(parportfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", parportfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				parportmsg.command = PARPORT_SEQUENCE_START;
				parportmsg.bit = startbits;
				if (write(parportctl, &parportmsg, sizeof(parportmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", parportfifoname, "'\n", (char *) NULL);
					close(parportctl);
					return TCL_ERROR;
				}
				
				if (close(parportctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", parportfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: parport start <parport#> [<parport#> ... ]\n", (char *) NULL);
			return TCL_ERROR;

/*** parport stop ***/
		} else if (argchar == 's' && strncmp(argv[argindex], "stop", arglength) == 0) {

			if (argindex < argc-1) {	
				int stopbits=0;
				
				for(argindex++; argindex < argc; argindex++) {
					sscanf(argv[argindex], "%i", &parportbit);
					
					if (parportbit >=1 && parportbit <=8) {
						stopbits |= (1 << (parportbit-1));
					} else {
						Tcl_AppendResult(interp, "ERROR: wrong <parport#>\n", (char *) NULL);
						return TCL_ERROR;
					}
				}
						
				/* Zuerst die parport Kommando FIFO oeffnen */

				if ((parportctl = open(parportfifoname, O_WRONLY)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't open FIFO '", parportfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}

				parportmsg.command = PARPORT_SEQUENCE_STOP;
				parportmsg.bit = stopbits;
				if (write(parportctl, &parportmsg, sizeof(parportmsg)) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't write to FIFO '", parportfifoname, "'\n", (char *) NULL);
					close(parportctl);
					return TCL_ERROR;
				}
				
				if (close(parportctl) < 0) {
					Tcl_AppendResult(interp, "ERROR: can't close FIFO '", parportfifoname, "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				return TCL_OK;
			}
			
			Tcl_AppendResult(interp, "usage: parport stop <parport#> [<parport#> ... ]\n", (char *) NULL);
			return TCL_ERROR;
			
/*** unbekannter Befehl: ***/
		} else {
			goto parport_Help;
		}
	} else {
parport_Help:

		Tcl_AppendResult(interp, "\nusage: parport [flags] <command> [options]\n\n",
			   					 "  [flags]:    '-old'\t use old rf-parport\n\n",
							 	 "  <command>:  'program <parport#> <...>' or\n",
								 "              '<parport#> <...>'             program parportsequence <parport#> \n",
								 "              'start <parport#>              start parport sequence <parport#>\n\n"
								 "              'stop <parport#>               stop parport sequence <parport#>\n\n"
								 "  use 'parport <command>' for more info!\n", (char *) NULL);
		return TCL_ERROR;
	}
	return TCL_ERROR;
}
