#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <ctype.h>

#include <tcl.h>
#include "../gpib/gpib_drv.h"
#include "../rwadat/rwadat.h"
//#include <ib.h>

typedef char bool;

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

/*
 * Prototypen
 */

char * Exp_Config_Dir();
int  i3e_input(char *adf, char *data, int len);
int  i3e_output(char *adf,void *data,int anzahl);
	
char sinfo[32000];

int tek_read(char *i3eadd, char *channel, char *datafilename, char *files, char *retmsg)
{
	char *buffer, *sptr;
	float fdummy, xincr, xzero, ymult, yoff;
	char command[100],result[1100], filename[100];
	char xunit[8]="s", yunit[8]="V";
	int numberofpoints, numberofbytes, datasize=1, realbytes, error;
	FILE  *paramfile;
	
	const int maxheadersize=7;
	int headersize;

	sprintf(command, "data:source %s", channel);
	i3e_output(i3eadd, command, strlen(command));

		
	sprintf(command, "wfmp:byt_n %d;bn_f ri;byt_o msb;enc bin;nr_p?",
			datasize);
	i3e_output(i3eadd, command, strlen(command));
	i3e_input(i3eadd, result, 100);

	sscanf(result, "%f", &fdummy);
	numberofpoints = (int)fdummy;

	numberofbytes = maxheadersize + datasize * numberofpoints;

	if (!(buffer = malloc(numberofbytes+100))) {
		printf("ERROR: Konnte keine %d Bytes fr Daten reservieren\n", numberofbytes);
		return -1;
	}
	
	sprintf(command, "curv?;");
	i3e_output(i3eadd, command, strlen(command));
	
	realbytes=i3e_input(i3eadd, (void *)buffer, numberofbytes+100);

	if (buffer[0] != '#') {
		return -1;	
	}
	
	result[0]=buffer[1];
	result[1]=0;

	headersize = 2 + atoi(result);
	
	/* DESC AUSWERTEN */

	sinfo[0] = 0;

/*	sprintf(command, "wfmp:wfid?;");
	i3e_output(i3eadd, command, strlen(command));
	i3e_input(i3eadd, result, 100);
	sscanf(result, "%*s %s coupling, %f V/div, %f s/div, %*d points, %s mode", 
			coupling, &vdiv, &tdiv, mode);*/
	
	sprintf(command, "wfmp:xin?;");
	i3e_output(i3eadd, command, strlen(command));
	i3e_input(i3eadd, result, 100);
	sscanf(result, "%f", &xincr);
	
	sprintf(command, "wfmp:xze?;");
	i3e_output(i3eadd, command, strlen(command));
	i3e_input(i3eadd, result, 100);
	sscanf(result, "%f", &xzero);
		
	sprintf(command, "wfmp:ymu?;");
	i3e_output(i3eadd, command, strlen(command));
	i3e_input(i3eadd, result, 100);
	sscanf(result, "%f", &ymult);
		
	sprintf(command, "wfmp:yof?;");
	i3e_output(i3eadd, command, strlen(command));
	i3e_input(i3eadd, result, 100);
	sscanf(result, "%f", &yoff);
		

/*	sprintf(command, "wfmp:xun?;");
	i3e_output(i3eadd, command, strlen(command));
	i3e_input(i3eadd, result, 100);
	sscanf(result, "\"%s", xunit);
		
	sprintf(command, "wfmp:yun?;");
	i3e_output(i3eadd, command, strlen(command));
	i3e_input(i3eadd, result, 100);
	sscanf(result, "\"%s", yunit);

	if (strlen(xunit)>=4) {
		xunit[4]=0;
	} else {
		xunit[strlen(xunit)-1]=0;
	}
	
	if (strlen(yunit)>=4) {
		yunit[4]=0;
	} else {
		yunit[strlen(yunit)-1]=0;
	}*/
	
	sprintf(sinfo, "\nTB=%gs VD=%gV TRD=%gs CHCOUP=%s\n\n",
			numberofpoints*xincr/10, 25*ymult, xzero, "n/a");

	/* ASCII-Files anhaengen */
	if (files != NULL) {
		sptr = strtok(files, "@; ");
		while (sptr != NULL) {
			strcpy(filename, sptr);
			
			/* zuerst versuchen, das file im aktuellen Verzeichnis zu lesen */
			paramfile = fopen(filename, "r");
			if (paramfile > 0) {
				realbytes = fread(result,1, 1024l,paramfile);
				result[realbytes] = 0;
				strcat(sinfo, filename);
				strcat(sinfo, ":\n");
				strcat(sinfo, result);
				fclose(paramfile);
			} else {
				/* dann versuchen, das File aus dem ConfigDir zu lesen */
				strcpy(filename, Exp_Config_Dir());
				strcat(filename, "/params/");
				strcat(filename, sptr);
				paramfile = fopen(filename, "r");
				if (paramfile) {
					realbytes = fread(result,1, 1024l,paramfile);
					result[realbytes] = 0;
					strcat(sinfo, sptr);
					strcat(sinfo, "+:\n  ");
					strcat(sinfo, result);
					fclose(paramfile);
				} 
			}
			sptr = strtok(NULL, "@; ");
		};
	}
	
	error = wadat(NULL, buffer+headersize, 'b', 'b', datafilename, 0,
				   numberofpoints,
				   1.0l, ymult,
				   0.0l, -yoff*ymult, 
				   xunit, yunit,
				   0.0l, numberofpoints * xincr,
				   'L', (void *) sinfo, (int) strlen(sinfo), 0);

	sprintf(retmsg, "%d Datenbytes uebertragen\n", numberofpoints);
	
	return 0;
}
	
	
int Tcl_TekCmd(ClientData dummy, Tcl_Interp * interp, int argc, char **argv)
{
	// int fehler = 0;
	char argchar, retmsg[100]="";
	int argindex, arglength, i;

	// bool READ_OLD_LECROY = FALSE;	// Option: -old

	/* Optionen parsen und aus dem Argumentfeld entfernen: */

	for (argindex = 1; argindex < argc;) {
		if (argv[argindex][0] == '-') {

			/* Hier die Optionen abfragen: */
			/*if (strcmp(argv[argindex], "-old") == 0) {
				READ_OLD_LECROY = TRUE;
			} else */{
				Tcl_AppendResult(interp, "ERROR: unknown option '", argv[argindex], "'\n", (char *) NULL);
				return TCL_ERROR;
			}

			/* Zeiger auf Argumente verschieben: */
			if (argindex < argc) {
				for (i = argindex; i < argc; i++)
					argv[i] = argv[i + 1];
			}
			argc--;
		} else
			argindex++;
	}

	if (argc < 3)
		goto Tek_Help;

	/* Argumentindex wieder auf den Beginn der Argumente setzen */
	argindex = 1;

	/* Nun die Argumente parsen: */
	
	if (argc > 1) {
		argchar = argv[argindex][0];
		arglength = strlen(argv[argindex]);
		
		if (argchar == 'r' && strncmp(argv[argindex], "read", arglength) == 0) {
			char *tek_name, *tek_ch, *filename;
			
			argindex++;

			if (argc - argindex == 3 || argc-argindex ==4) {
				tek_name = argv[argindex];
				
				/*if (tek_address & ERR) {
					Tcl_AppendResult(interp, "ERROR: gpib-Device '", argv[argindex], "' not available\n", (char *) NULL);
					return TCL_ERROR;
				}*/
		
				argindex++;
				tek_ch=argv[argindex];
				
/*				if (!(tolower(argv[argindex][0]) == 'c' && isdigit(argv[argindex][1]) &&
							strlen(argv[argindex])==2)) {

					Tcl_AppendResult(interp, "ERROR: wrong Channel # '", argv[argindex], "'\n", (char *) NULL);
					return TCL_ERROR;
				}
				
				tek_ch = argv[argindex];
				tek_channel = atoi(&argv[argindex][1]);
				
				if (tek_channel < 1 || tek_channel > 2) {
					Tcl_AppendResult(interp, "ERROR: Channel #", argv[argindex], " not 1 or 2\n", (char *) NULL);
					return TCL_ERROR;
				}*/
				
				argindex++;
				
				filename = argv[argindex];
				
			} else {
				Tcl_AppendResult(interp, "ERROR: Wrong number of arguments\n", (char *) NULL);
				return TCL_ERROR;
				
			}
				
				argindex++;		
				
				tek_read(tek_name, tek_ch, filename, argv[argindex], retmsg);
				
				Tcl_AppendResult(interp, retmsg, (char *) NULL);
		}
		return TCL_OK;
		
	} else {
Tek_Help:
		Tcl_AppendResult(interp, "USAGE: tek <cmd> <i3e_label> <chan> <outfile>\n ", (char *) NULL);
		return TCL_ERROR;
	}
}
